package org.jeecg.modules.stm.bcs.handle.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.bcs.handle.entity.BcsHandleRecord;
import org.jeecg.modules.stm.bcs.handle.service.IBcsHandleMethodService;
import org.jeecg.modules.stm.bcs.handle.service.IBcsHandleRecordService;
import org.jeecg.modules.stm.bcs.handle.entity.BcsHandleMethod;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;


import org.jeecg.common.aspect.annotation.AutoLog;

/**
 * @Description: 执行情况
 * @Author: jeecg-boot
 * @Date:   2025-09-25
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/bcs.handle/bcsHandleRecord")
@Slf4j
public class BcsHandleRecordController extends JeecgController<BcsHandleRecord, IBcsHandleRecordService> {
	@Autowired
	private IBcsHandleRecordService bcsHandleRecordService;
	 @Autowired
	 private IBcsHandleMethodService bcsHandleMethodService;
	
	/**
	 * 分页列表查询
	 *
	 * @param bcsHandleRecord
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "执行情况-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<BcsHandleRecord>> queryPageList(BcsHandleRecord bcsHandleRecord,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<BcsHandleRecord> queryWrapper = QueryGenerator.initQueryWrapper(bcsHandleRecord, req.getParameterMap());
		Page<BcsHandleRecord> page = new Page<BcsHandleRecord>(pageNo, pageSize);
		IPage<BcsHandleRecord> pageList = bcsHandleRecordService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param bcsHandleRecord
	 * @return
	 */
	@AutoLog(value = "执行情况-添加")
	  
	//@RequiresPermissions("bcs.handle:bcs_handle_record:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody BcsHandleRecord bcsHandleRecord) {
		bcsHandleRecordService.save(bcsHandleRecord);
		BcsHandleMethod bcsHandleMethod =new BcsHandleMethod();
		bcsHandleMethod.setId(bcsHandleRecord.getMethodId());
		bcsHandleMethod.setContent("已执行");
		bcsHandleMethodService.updateById(bcsHandleMethod);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param bcsHandleRecord
	 * @return
	 */
	@AutoLog(value = "执行情况-编辑")
	  
	//@RequiresPermissions("bcs.handle:bcs_handle_record:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody BcsHandleRecord bcsHandleRecord) {
		bcsHandleRecordService.updateById(bcsHandleRecord);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "执行情况-通过id删除")
	  
	//@RequiresPermissions("bcs.handle:bcs_handle_record:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		bcsHandleRecordService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "执行情况-批量删除")
	  
	//@RequiresPermissions("bcs.handle:bcs_handle_record:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.bcsHandleRecordService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "执行情况-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<BcsHandleRecord> queryById(@RequestParam(name="id",required=true) String id) {
		BcsHandleRecord bcsHandleRecord = bcsHandleRecordService.getById(id);
		if(bcsHandleRecord==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(bcsHandleRecord);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param bcsHandleRecord
    */
	// @RequiresPermissions("bcs.handle:bcs_handle_record:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, BcsHandleRecord bcsHandleRecord) {
        return super.exportXls(request, bcsHandleRecord, BcsHandleRecord.class, "执行情况");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
	// @RequiresPermissions("bcs.handle:bcs_handle_record:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, BcsHandleRecord.class);
    }

}
